'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _SVGCancel = require('./SVGCancel');

var _SVGCancel2 = _interopRequireDefault(_SVGCancel);

var _helperFunctions = require('./helperFunctions');

var _defaultStyles = require('./defaultStyles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var ModalDialog = function ModalDialog(_ref) {
	var toggleModal = _ref.toggleModal,
	    dataTestId = _ref.dataTestId,
	    renderBody = _ref.renderBody,
	    renderHeader = _ref.renderHeader,
	    defaultCloseModalButton = _ref.defaultCloseModalButton,
	    renderButtons = _ref.renderButtons,
	    renderCloseModalButton = _ref.renderCloseModalButton,
	    _ref$containerPropsOv = _ref.containerPropsOverride,
	    containerPropsOverride = _ref$containerPropsOv === undefined ? {} : _ref$containerPropsOv,
	    _ref$containerPropsAp = _ref.containerPropsAppend,
	    containerPropsAppend = _ref$containerPropsAp === undefined ? {} : _ref$containerPropsAp,
	    _ref$useCustomStyleA = _ref.useCustomStyleA,
	    useCustomStyleA = _ref$useCustomStyleA === undefined ? false : _ref$useCustomStyleA;

	var getHeaderProps = function getHeaderProps() {
		var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _onClick = _ref2.onClick,
		    className = _ref2.className,
		    style = _ref2.style,
		    props = _objectWithoutProperties(_ref2, ['onClick', 'className', 'style']);

		return _extends({
			onClick: function onClick(e) {
				for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					args[_key - 1] = arguments[_key];
				}

				e.stopPropagation();
				_onClick && _onClick.apply(undefined, [e].concat(args));
			},
			className: className ? 'modaldialog__header ' + className : 'modaldialog__header',
			style: style ? _extends({}, _defaultStyles.defaultStyles.header, style) : _defaultStyles.defaultStyles.header
		}, props);
	};
	var getCloseModalButtonProps = function getCloseModalButtonProps() {
		var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _onClick2 = _ref3.onClick,
		    className = _ref3.className,
		    style = _ref3.style,
		    props = _objectWithoutProperties(_ref3, ['onClick', 'className', 'style']);

		return _extends({
			onClick: function onClick(e) {
				for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
					args[_key2 - 1] = arguments[_key2];
				}

				e.stopPropagation();
				toggleModal();
				_onClick2 && _onClick2.apply(undefined, [e].concat(args));
			},
			className: className ? 'modaldialog__closemodalbutton ' + className : 'modaldialog__closemodalbutton',
			style: style ? _extends({}, _defaultStyles.defaultStyles.closemodalbutton, style) : _defaultStyles.defaultStyles.closemodalbutton
		}, props);
	};
	var getBodyProps = function getBodyProps() {
		var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _onClick3 = _ref4.onClick,
		    className = _ref4.className,
		    style = _ref4.style,
		    props = _objectWithoutProperties(_ref4, ['onClick', 'className', 'style']);

		return _extends({
			onClick: function onClick(e) {
				for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
					args[_key3 - 1] = arguments[_key3];
				}

				e.stopPropagation();
				_onClick3 && _onClick3.apply(undefined, [e].concat(args));
			},
			className: className ? 'modaldialog__body ' + className : 'modaldialog__body',
			style: style ? _extends({}, _defaultStyles.defaultStyles.body, style) : _defaultStyles.defaultStyles.body
		}, props);
	};
	var getButtonsProps = function getButtonsProps() {
		var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _onClick4 = _ref5.onClick,
		    className = _ref5.className,
		    style = _ref5.style,
		    props = _objectWithoutProperties(_ref5, ['onClick', 'className', 'style']);

		return _extends({
			onClick: function onClick(e) {
				for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
					args[_key4 - 1] = arguments[_key4];
				}

				e.stopPropagation();
				_onClick4 && _onClick4.apply(undefined, [e].concat(args));
			},
			className: className ? 'modaldialog__buttons ' + className : 'modaldialog__buttons',
			style: style ? _extends({}, _defaultStyles.defaultStyles.buttons, style) : _defaultStyles.defaultStyles.buttons
		}, props);
	};
	var getButtonProps = function getButtonProps() {
		var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _onClick5 = _ref6.onClick,
		    className = _ref6.className,
		    style = _ref6.style,
		    props = _objectWithoutProperties(_ref6, ['onClick', 'className', 'style']);

		return _extends({
			onClick: function onClick(e) {
				for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
					args[_key5 - 1] = arguments[_key5];
				}

				e.stopPropagation();
				_onClick5 && _onClick5.apply(undefined, [e].concat(args));
			},
			className: className ? 'modaldialog__button ' + className : 'modaldialog__button',
			style: style ? _extends({}, _defaultStyles.defaultStyles.button, style) : _defaultStyles.defaultStyles.button
		}, props);
	};
	var getContainerProps = function getContainerProps() {
		var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _onClick6 = _ref7.onClick,
		    className = _ref7.className,
		    style = _ref7.style,
		    props = _objectWithoutProperties(_ref7, ['onClick', 'className', 'style']);

		return _extends({
			onClick: function onClick(e) {
				for (var _len6 = arguments.length, args = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
					args[_key6 - 1] = arguments[_key6];
				}

				e.stopPropagation();
				_onClick6 && _onClick6.apply(undefined, [e].concat(args));
			},
			className: className ? 'modaldialog__container ' + className : 'modaldialog__container',
			style: style ? _extends({}, _defaultStyles.defaultStyles.container, style) : _defaultStyles.defaultStyles.container
		}, props);
	};
	return _react2.default.createElement(
		_react2.default.Fragment,
		null,
		_react2.default.createElement(
			'div',
			_extends({
				'data-testid': dataTestId,
				style: containerPropsAppend.style ? _extends({}, _defaultStyles.defaultStyles.container, containerPropsAppend.style) : _defaultStyles.defaultStyles.container,
				className: containerPropsAppend.className ? containerPropsAppend.className + ' modaldialog__container' : 'modaldialog__container',
				onClick: function onClick(e) {
					e.stopPropagation();
				}
			}, containerPropsOverride),
			renderCloseModalButton && renderCloseModalButton({ getCloseModalButtonProps: getCloseModalButtonProps }),
			defaultCloseModalButton && !renderCloseModalButton && _react2.default.createElement(
				'div',
				_extends({}, getCloseModalButtonProps()),
				_react2.default.createElement(_SVGCancel2.default, null)
			),
			renderHeader && renderHeader({ getHeaderProps: getHeaderProps }),
			renderBody && renderBody({ getBodyProps: getBodyProps }),
			renderButtons && renderButtons({ getButtonsProps: getButtonsProps, getButtonProps: getButtonProps, toggleModal: toggleModal })
		)
	);
};

ModalDialog.defaultProps = {
	defaultCloseModalButton: false,
	dataTestId: '',

	classNameAppend: '',
	classNameOverride: '',
	style: {}
};

var hideScrollBar = function hideScrollBar() {
	return (0, _helperFunctions.styleElement)('body', {
		overflow: 'hidden',
		marginRight: '2rem'
	});
};
var showScrollBar = function showScrollBar() {
	return (0, _helperFunctions.styleElement)('body', {
		overflow: 'auto',
		marginRight: '0rem'
	});
};

var hideScrollNav = function hideScrollNav() {
	(0, _helperFunctions.styleElement)('.scrollnav__scrolltop', { display: 'none' });
	(0, _helperFunctions.styleElement)('.scrollnav__scrollbottom', { display: 'none' });
};

var showScrollNav = function showScrollNav() {
	(0, _helperFunctions.styleElement)('.scrollnav__scrolltop', { display: 'block' });
	(0, _helperFunctions.styleElement)('.scrollnav__scrollbottom', { display: 'block' });
};

var enhance = (0, _recompose.compose)((0, _recompose.lifecycle)({
	componentDidMount: function componentDidMount() {
		var toggleModal = this.props.toggleModal;

		document.addEventListener('keydown', function cb(e) {
			if (e.keyCode === 27) {
				toggleModal();
				e.currentTarget.removeEventListener(e.type, cb);
			}
		});
		if (typeof window !== 'undefined') {
			window.modalCount ? window.modalCount++ : window.modalCount = 1;
			console.log('window.modalCount: ', window.modalCount);
		}
		hideScrollNav();
		hideScrollBar();
		(0, _helperFunctions.styleElement)('.floatingbasket__container', { right: '9999rem' });
		(0, _helperFunctions.styleElement)('.showtoggle__container--cartpreview', { right: '9999rem' });
		// styleElement(`.floatingbasket__container`, { display: `none` })
		// styleElement(`.showtoggle__container--cartpreview`, { display: `none` })
	},
	componentWillUnmount: function componentWillUnmount() {
		if (typeof window !== 'undefined') {
			window.modalCount ? window.modalCount-- : window.modalCount = 0;
			console.log('window.modalCount: ', window.modalCount);
			var floatingBasketRight = 0;
			if (window.modalCount === 0) {
				showScrollNav();
				showScrollBar();
				(0, _helperFunctions.styleElement)('.floatingbasket__container', { right: '' + floatingBasketRight });
				(0, _helperFunctions.styleElement)('.showtoggle__container--cartpreview', { right: '' + floatingBasketRight });
			}
		}
		// styleElement(`.floatingbasket__container`, { display: `none` })
		// styleElement(`.showtoggle__container--cartpreview`, { display: `none` })
	}
}));

ModalDialog.propTypes = {
	buttons: _propTypes2.default.object
};
ModalDialog.defaultProps = {
	defaultCloseModalButton: true
};

exports.default = enhance(ModalDialog);