'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _defaultStyles = require('./defaultStyles');

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _RTGFade = require('./RTGFade');

var _RTGFade2 = _interopRequireDefault(_RTGFade);

var _Step = require('./Step');

var _Step2 = _interopRequireDefault(_Step);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } //write toggleModal inside recompose handler
// adjust styling for 2+ steps


var MultiplePageModal = function MultiplePageModal(_ref) {
	var pageNavigationButtonsAreDisabled = _ref.pageNavigationButtonsAreDisabled,
	    renderTrigger = _ref.renderTrigger,
	    closeModalButtonIsRendered = _ref.closeModalButtonIsRendered,
	    pages = _ref.pages,
	    steps = _ref.steps,
	    currentPage = _ref.currentPage,
	    goToNextPage = _ref.goToNextPage,
	    goToPreviousPage = _ref.goToPreviousPage,
	    setCurrentPageTo = _ref.setCurrentPageTo,
	    modalIsOpen = _ref.modalIsOpen,
	    toggleModal = _ref.toggleModal,
	    isTesting = _ref.isTesting,
	    cssClassExtra_$_ModalDialogHeader = _ref.cssClassExtra_$_ModalDialogHeader,
	    containerPropsOverride = _ref.containerPropsOverride,
	    containerPropsAppend = _ref.containerPropsAppend,
	    _ref$backgroundPropsO = _ref.backgroundPropsOverride,
	    backgroundPropsOverride = _ref$backgroundPropsO === undefined ? {} : _ref$backgroundPropsO,
	    _ref$backgroundPropsA = _ref.backgroundPropsAppend,
	    backgroundPropsAppend = _ref$backgroundPropsA === undefined ? {} : _ref$backgroundPropsA,
	    renderNextButton = _ref.renderNextButton,
	    renderBackButton = _ref.renderBackButton;

	var renderPageNavigationButtons = function renderPageNavigationButtons(_ref2) {
		var currentPage = _ref2.currentPage,
		    length = _ref2.length,
		    getButtonProps = _ref2.getButtonProps;

		var renderNext = function renderNext() {
			return renderNextButton({
				getButtonProps: getButtonProps,
				disabled: pageNavigationButtonsAreDisabled,
				goToNextPage: goToNextPage
			});
		};
		var renderBack = function renderBack() {
			return renderBackButton({ getButtonProps: getButtonProps, goToPreviousPage: goToPreviousPage });
		};
		if (currentPage === 0) {
			return renderNext();
		}
		if (currentPage === length - 1) {
			return renderBack();
		} else {
			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				renderNext(),
				renderBack()
			);
		}
	};

	var renderSteps = function renderSteps(currentPageNumber, steps) {
		return _react2.default.createElement(
			'div',
			{
				className: _style2.default.dynamic([['2468848418', [300 * steps.length, 300 * steps.length]]]) + ' ' + 'multiplepagemodal__steps'
			},
			_react2.default.createElement(_style2.default, {
				styleId: '2468848418',
				css: '.multiplepagemodal__steps{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}@media screen and (max-width:' + 300 * steps.length + 'px){.multiplepagemodal__steps{-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;}.step__container--active--notlast--enabled{border-width:0 0 1px 0;border-style:solid;border-color:rgba(34,36,38,0.15);}.step__container--inactive--notlast--enabled{border-width:0 0 1px 0;border-style:solid;border-color:rgba(34,36,38,0.15);}.step__container--active--notlast--enabled::after{bottom:-15%;right:50%;border-width:0 0 1px 1px;border-style:solid;border-color:rgba(34,36,38,0.15);}.step__container--inactive--notlast--enabled::after{bottom:-15%;right:50%;border-width:0 0 1px 1px;border-style:solid;border-color:rgba(34,36,38,0.15);}}@media screen and (min-width:' + 300 * steps.length + 'px){.multiplepagemodal__steps .step__container{-webkit-flex-basis:30rem;-ms-flex-preferred-size:30rem;flex-basis:30rem;}.step__container--active--notlast--enabled{border-width:0 1px 0 0;border-style:solid;border-color:rgba(34,36,38,0.15);}.step__container--inactive--notlast--enabled{border-width:0 1px 0 0;border-style:solid;border-color:rgba(34,36,38,0.15);}.step__container--active--notlast--enabled::after{top:50%;right:0;border-width:0 1px 1px 0;border-style:solid;border-color:rgba(34,36,38,0.15);}.step__container--inactive--notlast--enabled::after{top:50%;right:0;border-width:0 1px 1px 0;border-style:solid;border-color:rgba(34,36,38,0.15);}}',
				dynamic: [300 * steps.length, 300 * steps.length]
			}),
			steps.map(function (_ref3, stepNumber) {
				var renderIcon = _ref3.renderIcon,
				    renderTitle = _ref3.renderTitle,
				    renderSubtitle = _ref3.renderSubtitle,
				    renderStep = _ref3.renderStep;
				return _react2.default.createElement(_Step2.default, {
					onClick: function onClick() {
						return setCurrentPageTo(stepNumber);
					},
					key: stepNumber,
					isActive: currentPageNumber === stepNumber,
					isDisabled: stepNumber > currentPageNumber && pageNavigationButtonsAreDisabled,
					isComplete: currentPageNumber > stepNumber,
					isLast: stepNumber === steps.length - 1,
					renderStep: renderStep,
					renderIcon: renderIcon,
					renderTitle: renderTitle,
					renderSubtitle: renderSubtitle
				});
			})
		);
	};
	var getTriggerProps = function getTriggerProps() {
		var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _onClick = _ref4.onClick,
		    className = _ref4.className,
		    props = _objectWithoutProperties(_ref4, ['onClick', 'className']);

		return _extends({
			onClick: function onClick(e) {
				for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					args[_key - 1] = arguments[_key];
				}

				e.stopPropagation();
				toggleModal();
				_onClick && _onClick.apply(undefined, [e].concat(args));
			},
			className: className ? 'actionmodal__trigger ' + className : 'actionmodal__trigger'

		}, props);
	};
	return _react2.default.createElement(
		_react2.default.Fragment,
		null,
		renderTrigger && renderTrigger({ modalIsOpen: modalIsOpen, toggleModal: toggleModal, getTriggerProps: getTriggerProps }),
		_react2.default.createElement(
			_RTGFade2.default,
			_extends({
				duration: 100,
				className: backgroundPropsAppend.className ? 'modal__background ' + backgroundPropsAppend.className : 'modal__background',
				style: isTesting ? null : backgroundPropsAppend.style ? _extends({}, _defaultStyles.defaultStyles.background, backgroundPropsAppend.style) : _defaultStyles.defaultStyles.background,
				'in': isTesting ? true : modalIsOpen,
				onClick: toggleModal
			}, backgroundPropsOverride),
			pages.map(function (page, i) {
				return currentPage === i && _react2.default.createElement(_ModalDialog2.default, {
					key: currentPage,
					containerPropsOverride: containerPropsOverride,
					containerPropsAppend: containerPropsAppend,
					closeModalButtonIsRendered: closeModalButtonIsRendered,
					renderHeader: !steps ? function (_ref5) {
						var getHeaderProps = _ref5.getHeaderProps;
						return _react2.default.createElement(
							'div',
							getHeaderProps({ className: cssClassExtra_$_ModalDialogHeader }),
							page.renderHeader()
						);
					} : function (_ref6) {
						var getHeaderProps = _ref6.getHeaderProps;
						return _react2.default.createElement(
							'div',
							getHeaderProps({ className: cssClassExtra_$_ModalDialogHeader }),
							renderSteps(i, steps)
						);
					},
					renderButtons: function renderButtons(_ref7) {
						var getButtonProps = _ref7.getButtonProps,
						    getButtonsProps = _ref7.getButtonsProps;
						return _react2.default.createElement(
							'div',
							_extends({}, getButtonsProps()),
							page.renderButtons && page.renderButtons({ getButtonProps: getButtonProps }),
							renderPageNavigationButtons({
								currentPage: i,
								length: pages.length,
								getButtonProps: getButtonProps
							})
						);
					},
					renderBody: function renderBody(_ref8) {
						var getBodyProps = _ref8.getBodyProps;
						return _react2.default.createElement(
							'div',
							_extends({}, getBodyProps(), { className: page.cssClassOverride_$_body }),
							page.renderBody({ setCurrentPageTo: setCurrentPageTo, toggleModal: toggleModal })
						);
					},
					toggleModal: toggleModal
				});
			})
		)
	);
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('modalIsOpen', 'setModalIsOpenTo', false), (0, _recompose.withState)('currentPage', 'setCurrentPageTo', 0), (0, _recompose.withHandlers)({
	toggleModal: function toggleModal(_ref9) {
		var setModalIsOpenTo = _ref9.setModalIsOpenTo;
		return function () {
			setModalIsOpenTo(function (x) {
				return !x;
			});
		};
	},

	goToNextPage: function goToNextPage(_ref10) {
		var setCurrentPageTo = _ref10.setCurrentPageTo,
		    pages = _ref10.pages;
		return function () {
			setCurrentPageTo(function (n) {
				return n === pages.length - 1 ? n : n + 1;
			});
		};
	},
	goToPreviousPage: function goToPreviousPage(_ref11) {
		var setCurrentPageTo = _ref11.setCurrentPageTo;
		return function () {
			setCurrentPageTo(function (n) {
				return n === 0 ? n : n - 1;
			});
		};
	}
}), (0, _recompose.setPropTypes)({
	pages: _propTypes2.default.array.isRequired,
	steps: _propTypes2.default.arrayOf(_propTypes2.default.shape({
		renderIcon: _propTypes2.default.func.isRequired,
		renderTitle: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.string]).isRequired,
		renderSubtitle: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.string]).isRequired
	})).isRequired,
	renderTrigger: _propTypes2.default.func.isRequired,
	pageNavigationButtonsAreDisabled: _propTypes2.default.bool,
	closeModalButtonIsRendered: _propTypes2.default.bool,

	modalDialogContainerClassNameAppend: _propTypes2.default.string,
	cssClassExtra_$_ModalDialogHeader: _propTypes2.default.string,
	cssClassOverride_$_ModalDialogBody: _propTypes2.default.string,
	cssClassExtra_$_ModalBackground: _propTypes2.default.string,
	triggerClassNameOverride: _propTypes2.default.string,

	modalIsOpen: _propTypes2.default.bool.isRequired,
	currentPage: _propTypes2.default.number.isRequired,
	toggleModal: _propTypes2.default.func.isRequired,
	setCurrentPageTo: _propTypes2.default.func.isRequired,
	goToNextPage: _propTypes2.default.func.isRequired,
	goToPreviousPage: _propTypes2.default.func.isRequired
}));

MultiplePageModal.defaultProps = {
	pageNavigationButtonsAreDisabled: false,
	renderNextButton: function renderNextButton(_ref12) {
		var getButtonProps = _ref12.getButtonProps,
		    goToNextPage = _ref12.goToNextPage,
		    disabled = _ref12.disabled;
		return _react2.default.createElement(
			'button',
			_extends({}, getButtonProps({ onClick: goToNextPage }), { disabled: disabled }),
			'NEXT'
		);
	},
	renderBackButton: function renderBackButton(_ref13) {
		var getButtonProps = _ref13.getButtonProps,
		    goToPreviousPage = _ref13.goToPreviousPage;
		return _react2.default.createElement(
			'button',
			_extends({}, getButtonProps({ onClick: goToPreviousPage })),
			'BACK'
		);
	}
};

exports.default = enhance(MultiplePageModal);