'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Transition = require('react-transition-group/Transition');

var _Transition2 = _interopRequireDefault(_Transition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var transitionStyles = {
  entering: {
    opacity: 0
  },
  entered: {
    opacity: 1
  }
};

var getDefaultStyle = function getDefaultStyle(duration) {
  return { transition: 'all ' + duration + 'ms cubic-bezier(0.4, 0, 0.2, 1) 0ms', opacity: 0 };
};

var RTGFade = function RTGFade(_ref) {
  var inProp = _ref.in,
      _ref$duration = _ref.duration,
      duration = _ref$duration === undefined ? 250 : _ref$duration,
      onClick = _ref.onClick,
      className = _ref.className,
      _ref$style = _ref.style,
      style = _ref$style === undefined ? {} : _ref$style,
      children = _ref.children;
  return _react2.default.createElement(
    _Transition2.default,
    { unmountOnExit: true, 'in': inProp, timeout: duration },
    function (state) {
      return _react2.default.createElement(
        'div',
        { onClick: onClick, className: className, style: _extends({}, getDefaultStyle(duration), style, transitionStyles[state]) },
        children
      );
    }
  );
};

exports.default = RTGFade;