'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _helperFunctions = require('./helperFunctions');

var _SVGDone = require('./SVGDone');

var _SVGDone2 = _interopRequireDefault(_SVGDone);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Step = function Step(_ref) {
	var nativeOnClick = _ref.onClick,
	    isDisabled = _ref.isDisabled,
	    isActive = _ref.isActive,
	    isComplete = _ref.isComplete,
	    renderStep = _ref.renderStep,
	    renderIcon = _ref.renderIcon,
	    renderSubtitle = _ref.renderSubtitle,
	    renderTitle = _ref.renderTitle,
	    isLast = _ref.isLast;

	var getClassName = function getClassName() {
		return (0, _helperFunctions.flippyTailClass)('step__container', [isActive, 'active', 'inactive'], [isLast, 'last', 'notlast'], [isDisabled, 'disabled', 'enabled']);
	};
	var getStepProps = function getStepProps() {
		var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var className = _ref2.className,
		    style = _ref2.style,
		    _onClick = _ref2.onClick,
		    props = _objectWithoutProperties(_ref2, ['className', 'style', 'onClick']);

		return _extends({
			className: className ? getClassName() + ' ' + className : getClassName(),
			onClick: function onClick(e) {
				for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					args[_key - 1] = arguments[_key];
				}

				e.stopPropagation();
				!isDisabled && nativeOnClick && nativeOnClick();
				!isDisabled && _onClick && _onClick.apply(undefined, [e].concat(args));
			}
		}, props);
	};
	return _react2.default.createElement(
		_react2.default.Fragment,
		null,
		_react2.default.createElement(_style2.default, {
			styleId: '2769304308',
			css: '.step__title{margin-bottom:0.25rem;font-weight:bold;font-size:85%;}.step__title--active{color:#4183c4;}.step__subtitle{font-size:70%;}.step__icon{margin-right:-0.25rem;}.step__container{position:relative;height:6rem;padding:1rem 2rem;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;color:silver;-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;cursor:pointer;}.step__container--inactive--last--disabled{border-width:0px 0px 0px 0;cursor:default;}.step__container--inactive--last--enabled{background:white;color:black;}.step__container--inactive--notlast--enabled{background:white;color:black;}.step__container--inactive--notlast--enabled::after{display:block;position:absolute;z-index:2;content:\'\';background-color:#fff;width:1rem;height:1rem;-webkit-transition:background-color .1s ease,opacity .1s ease,color .1s ease,box-shadow .1s ease;-webkit-transition:background-color .1s ease,opacity .1s ease,color .1s ease,box-shadow .1s ease;transition:background-color .1s ease,opacity .1s ease,color .1s ease,box-shadow .1s ease;-webkit-transform:translateY(-50%) translateX(50%) rotate(-45deg);-webkit-transform:translateY(-50%) translateX(50%) rotate(-45deg);-ms-transform:translateY(-50%) translateX(50%) rotate(-45deg);transform:translateY(-50%) translateX(50%) rotate(-45deg);}.step__container--active--last--enabled{background:#ebe8e8;color:black;}.step__container--active--notlast--enabled{background:#ebe8e8;color:black;}.step__container--active--notlast--enabled::after{display:block;position:absolute;z-index:2;content:\'\';background:#ebe8e8;width:1rem;height:1rem;-webkit-transition:background-color .1s ease,opacity .1s ease,color .1s ease,box-shadow .1s ease;-webkit-transition:background-color .1s ease,opacity .1s ease,color .1s ease,box-shadow .1s ease;transition:background-color .1s ease,opacity .1s ease,color .1s ease,box-shadow .1s ease;-webkit-transform:translateY(-50%) translateX(50%) rotate(-45deg);-webkit-transform:translateY(-50%) translateX(50%) rotate(-45deg);-ms-transform:translateY(-50%) translateX(50%) rotate(-45deg);transform:translateY(-50%) translateX(50%) rotate(-45deg);}'
		}),
		renderStep ? renderStep({ getStepProps: getStepProps, isActive: isActive, isComplete: isComplete, isDisabled: isDisabled, isLast: isLast }) : _react2.default.createElement(
			'div',
			{ onClick: !isDisabled ? nativeOnClick : undefined, className: 'jsx-2769304308' + ' ' + (getClassName() || '')
			},
			_react2.default.createElement(
				'div',
				{
					className: 'jsx-2769304308' + ' ' + 'step__icon'
				},
				isComplete ? _react2.default.createElement(_SVGDone2.default, { size: '36', fill: 'green' }) : renderIcon()
			),
			_react2.default.createElement(
				'div',
				{
					className: 'jsx-2769304308' + ' ' + 'step__info'
				},
				_react2.default.createElement(
					'div',
					{
						className: 'jsx-2769304308' + ' ' + ((0, _helperFunctions.flippyClass)(isActive, 'step__title', 'active', 'inactive') || '')
					},
					typeof renderTitle === 'function' ? renderTitle() : renderTitle
				),
				_react2.default.createElement(
					'div',
					{
						className: 'jsx-2769304308' + ' ' + 'step__subtitle'
					},
					typeof renderSubtitle === 'function' ? renderSubtitle() : renderSubtitle
				)
			)
		)
	);
};

Step.propTypes = {
	isActive: _propTypes2.default.bool.isRequired,
	isComplete: _propTypes2.default.bool.isRequired,
	isLast: _propTypes2.default.bool.isRequired,
	renderIcon: _propTypes2.default.func.isRequired,
	renderTitle: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.string]).isRequired,
	renderSubtitle: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.string]).isRequired
};
var enhance = (0, _recompose.compose)();
//	setStatic(`Icon`, Icon),
//	setStatic(`Title`, Title),
//	setStatic(`Subtitle`, Subtitle)

exports.default = enhance(Step);